require 'pathname'
require Pathname.new(__FILE__).parent + 'wiimote.rb'
require 'Win32API'

class Win32API
	WM_KEYDOWN = 0x0100
	WM_KEYUP   = 0x0101
	
	VK_BACK    = 0x0008
	VK_SPACE   = 0x0020
	VK_HOME    = 0x0024
	VK_LEFT    = 0x0025
	VK_UP      = 0x0026
	VK_RIGHT   = 0x0027
	VK_DOWN    = 0x0028
	
	def Win32API.GetForegroundWindow
		get_foreground_window = Win32API.new('user32', 'GetForegroundWindow', %w(v), 'i')
		
		get_foreground_window.call
	end
	
	def Win32API.SendMessage( hwnd , message , wparam ,lparam )
		send_message = Win32API.new( 'user32' , 'SendMessage' , %w(N N N P) , "N" )
		
		send_message.call( hwnd , message , wparam , lparam )
	end
	
	def Win32API.PostMessage( hwnd , message , wparam ,lparam )
		post_message = Win32API.new( 'user32' , 'PostMessage' , %w(N N N P) , "N" )
		
		post_message.call( hwnd , message , wparam , lparam )
	end
end

wiimote = Wiimote.new
wiimote.led_out

last_space, last_back = false, false

loop do
	wiimote.update
	
	space    = wiimote.a | wiimote.right | wiimote.down
	back     = wiimote.b | wiimote.left  | wiimote.up  
	succ     = wiimote.plus
	prev     = wiimote.minus
	move_top = wiimote.home
	
	case
	when space && !last_space
		hwnd = Win32API.GetForegroundWindow
		Win32API.PostMessage( hwnd, Win32API::WM_KEYDOWN, Win32API::VK_SPACE, 0 )
		Win32API.PostMessage( hwnd, Win32API::WM_KEYUP  , Win32API::VK_SPACE, 0 )
		
	when back  && !last_back
		hwnd = Win32API.GetForegroundWindow
		Win32API.PostMessage( hwnd, Win32API::WM_KEYDOWN, Win32API::VK_BACK , 0 )
		Win32API.PostMessage( hwnd, Win32API::WM_KEYUP  , Win32API::VK_BACK , 0 )
	
	when succ
		hwnd = Win32API.GetForegroundWindow
		Win32API.SendMessage( hwnd, Win32API::WM_KEYDOWN, Win32API::VK_SPACE, 0 )
		Win32API.SendMessage( hwnd, Win32API::WM_KEYUP  , Win32API::VK_SPACE, 0 )
	
	when prev
		hwnd = Win32API.GetForegroundWindow
		Win32API.SendMessage( hwnd, Win32API::WM_KEYDOWN, Win32API::VK_BACK , 0 )
		Win32API.SendMessage( hwnd, Win32API::WM_KEYUP  , Win32API::VK_BACK , 0 )
	
	when move_top
		hwnd = Win32API.GetForegroundWindow
		Win32API.PostMessage( hwnd, Win32API::WM_KEYDOWN, Win32API::VK_HOME , 0 )
		Win32API.PostMessage( hwnd, Win32API::WM_KEYUP  , Win32API::VK_HOME , 0 )
	
	end
	
	last_space, last_back = space, back
	
	sleep 0.1
end
