require 'pathname'
require Pathname.new(__FILE__).parent + 'wiimote.rb'

# enable motion sensors
wiimote = Wiimote.new
wiimote.enable_motion_sensor


last_states = ''
loop do
	# read data from a wiimote
	wiimote.update
	
	# check states of wiimote buttons
	states = []
	states << 'A'     if wiimote.a
	states << 'B'     if wiimote.b
	states << 'UP'    if wiimote.up
	states << 'DOWN'  if wiimote.down
	states << 'LEFT'  if wiimote.left
	states << 'RIGHT' if wiimote.right
	states << 'HOME'  if wiimote.home
	states << '1'     if wiimote.one
	states << '2'     if wiimote.two
	states << '+'     if wiimote.plus
	states << '-'     if wiimote.minus
	
	current_states = states.join(' ')
	
	
	# display current states of wiimote buttons
	puts current_states if current_states != last_states
	
	# save last states
	last_states = current_states
	
	
	# wait input
	sleep 0.015
end
