#ifndef __HID_H_INCLUDED__
#define __HID_H_INCLUDED__



#define UNICODE
#define _UNICODE

#include <windows.h>
#include <setupapi.h>
#include "hidsdi.h"

typedef struct {
	int product_id;
	int vendor_id;
	
	HDEVINFO device_info;
	PSP_DEVICE_INTERFACE_DATA p_device_interface;
	
	HIDD_ATTRIBUTES attributes;
	PHIDP_PREPARSED_DATA preparsed_data;
	HIDP_CAPS caps;
	
	OVERLAPPED overlapped;
	char *input_buffer;
	char *output_buffer;
	
	HANDLE hDevice;
} hid_t;

typedef void     ( __stdcall *GetGuidProc      )( GUID * );
typedef BOOLEAN  ( __stdcall *GetAttrProc      )( HANDLE, HIDD_ATTRIBUTES * );
typedef BOOLEAN  ( __stdcall *GetPreparsedProc )( HANDLE, PHIDP_PREPARSED_DATA * );
typedef NTSTATUS ( __stdcall *GetCapsProc      )( PHIDP_PREPARSED_DATA, PHIDP_CAPS );

typedef HDEVINFO ( __stdcall *SetupDiGetClassDevsProc             )( LPGUID, PCTSTR, HWND, DWORD );
typedef BOOLEAN  ( __stdcall *SetupDiGetDeviceInterfaceDetailProc )( HDEVINFO, PSP_DEVICE_INTERFACE_DATA, PSP_DEVICE_INTERFACE_DETAIL_DATA, DWORD, PDWORD, PSP_DEVINFO_DATA );
typedef BOOLEAN  ( __stdcall *SetupDiEnumDeviceInterfacesProc     )( HDEVINFO, PSP_DEVINFO_DATA, LPGUID, DWORD, PSP_DEVICE_INTERFACE_DATA );
typedef BOOLEAN  ( __stdcall *SetupDiDestroyDeviceInfoListProc    )( HDEVINFO );



#endif